#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire900six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six9004xi



# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six9004xi = {
                1:'-106x305y-839z',
                2:'-111x628y-634z',
                3:'-119x291y-842z',
                4:'-123x3y-891z',
                5:'-130x277y-846z',
                6:'-132x11y-890z',
                7:'-139x852y-251z',
                8:'-140x19y-888z',
                9:'-141x262y-849z',
                10:'-143x615y-641z',
                11:'-147x28y-887z',
                12:'-150x247y-852z',
                13:'-151x855y-236z',
                14:'-154x37y-885z',
                15:'-158x232y-854z',
                16:'-161x48y-884z',
                17:'-165x217y-857z',
                18:'-166x59y-882z',
                19:'-170x201y-860z',
                20:'-171x71y-880z',
                21:'-173x600y-647z',
                22:'-175x186y-862z',
                23:'-175x84y-878z',
                24:'-178x170y-865z',
                25:'-178x97y-876z',
                26:'-180x111y-874z',
                27:'-180x155y-867z',
                28:'-181x125y-872z',
                29:'-181x140y-870z',
                30:'-183x841y-259z',
                31:'-195x843y-244z',
                32:'-202x584y-653z',
                33:'-226x828y-268z',
                34:'-230x567y-659z',
                35:'-238x829y-253z',
                36:'-256x548y-665z',
                37:'-268x813y-276z',
                38:'-26x364y-822z',
                39:'-280x813y-262z',
                40:'-281x528y-671z',
                41:'-305x506y-677z',
                42:'-310x795y-285z',
                43:'-321x795y-270z',
                44:'-327x484y-683z',
                45:'-348x461y-689z',
                46:'-350x775y-294z',
                47:'-361x775y-279z',
                48:'-367x437y-695z',
                49:'-385x412y-700z',
                50:'-388x753y-302z',
                51:'-400x752y-287z',
                52:'-401x386y-706z',
                53:'-415x360y-712z',
                54:'-426x729y-310z',
                55:'-428x333y-717z',
                56:'-438x728y-296z',
                57:'-439x306y-723z',
                58:'-448x279y-728z',
                59:'-44x354y-826z',
                60:'-453x15y-777z',
                61:'-456x252y-733z',
                62:'-459x39y-772z',
                63:'-461x703y-319z',
                64:'-462x224y-738z',
                65:'-464x64y-768z',
                66:'-466x197y-743z',
                67:'-467x90y-763z',
                68:'-469x116y-758z',
                69:'-469x169y-748z',
                70:'-470x143y-753z',
                71:'-473x701y-304z',
                72:'-496x675y-327z',
                73:'-508x673y-313z',
                74:'-528x646y-336z',
                75:'-540x643y-321z',
                76:'-559x614y-344z',
                77:'-567x698y-2z',
                78:'-571x612y-330z',
                79:'-588x582y-352z',
                80:'-600x578y-338z',
                81:'-603x667y-11z',
                82:'-615x548y-361z',
                83:'-61x343y-829z',
                84:'-627x544y-346z',
                85:'-637x634y-20z',
                86:'-640x513y-369z',
                87:'-651x508y-355z',
                88:'-663x476y-377z',
                89:'-669x600y-29z',
                90:'-674x471y-363z',
                91:'-684x439y-385z',
                92:'-695x434y-371z',
                93:'-700x564y-38z',
                94:'-702x400y-393z',
                95:'-713x395y-379z',
                96:'-719x361y-401z',
                97:'-728x526y-47z',
                98:'-733x322y-409z',
                99:'-745x281y-417z',
                100:'-754x487y-56z',
                101:'-755x241y-425z',
                102:'-762x200y-433z',
                103:'-767x159y-441z',
                104:'-769x36y-464z',
                105:'-770x117y-449z',
                106:'-771x76y-457z',
                107:'-778x447y-65z',
                108:'-77x331y-833z',
                109:'-79x639y-628z',
                110:'-800x405y-74z',
                111:'-811x395y-430z',
                112:'-819x362y-83z',
                113:'-836x318y-92z',
                114:'-851x274y-101z',
                115:'-863x229y-110z',
                116:'-872x183y-119z',
                117:'-880x137y-128z',
                118:'-884x91y-137z',
                119:'-886x44y-145z',
                120:'-92x318y-836z',
                121:'-95x861y-242z'}        
#"
#/>


# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire900six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire900six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE900SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE900SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE900SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE900SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE900SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six9004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE900SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE900SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE900SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six900x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six900x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE900SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE900SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE900SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire900six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
